//
//  main.m
//  PROJECTNAME
//
//  Created by FULLUSERNAME on DATE.
//  Copyright (c) YEAR by FULLUSERNAME. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "main.h"

#include "FSPlugInObject.h"
#include "FSPlugInObjectCocoa.h"

struct plugin_PROJECTNAMEASIDENTIFIER
{
	FSPlugInObject	header;
	
	NSArray			*paths;
	NSMutableArray	*children;
};

void *plugin_alloc(const char *path,const char *dylib_path)
{
plugin_PROJECTNAMEASIDENTIFIER		*context;

	corelink();
	
	context = (plugin_PROJECTNAMEASIDENTIFIER *)malloc(sizeof(plugin_PROJECTNAMEASIDENTIFIER));
	memset(context,0x00,sizeof(plugin_PROJECTNAMEASIDENTIFIER));
	context->header.plugin_interface = (void *)&plugin_interface;
	
	{
	NSBundle		*bundle;
	NSArray			*plist;
	NSMutableArray	*paths;
	NSEnumerator	*enumerator;
	NSString		*relativePath;
	
		bundle = [NSBundle bundleWithPath:[NSString stringWithCString:path]];
		plist = [NSArray arrayWithContentsOfFile:[bundle pathForResource:@"children" ofType:@"plist"]];
		if(!plist) goto fail;
		
		paths = [[NSMutableArray alloc] initWithCapacity:0];
		enumerator = [plist objectEnumerator];
		while((relativePath = [enumerator nextObject]) != nil)
		{
		NSString	*name,*ext,*directory;
		
			directory = [relativePath stringByDeletingLastPathComponent];
			name = [[relativePath lastPathComponent] stringByDeletingPathExtension];
			ext = [relativePath pathExtension];
			
			if([directory length] > 0)
				[paths addObject:[bundle pathForResource:name ofType:ext inDirectory:directory]];
			else
				[paths addObject:[bundle pathForResource:name ofType:ext]];
		}
		
		context->paths = paths;
		context->children = nil;
	}
	return context;

fail:
	free(context);
	return NULL;
}

void plugin_dealloc(plugin_PROJECTNAMEASIDENTIFIER *context)
{
	[context->children release];
	free(context);
}

void plugin_body_PROJECTNAMEASIDENTIFIER(void) {}

#pragma mark -

int plugin_interface(plugin_PROJECTNAMEASIDENTIFIER *context,unsigned long message,void **result)
{
NSAutoreleasePool	*pool = [[NSAutoreleasePool alloc] init];
int					returncode = -1;

	switch(message)
	{
		case FSCoreInterfaceMessage_RespondsTo:
			switch(*(unsigned long *)result)
			{
				case FSCoreInterfaceMessage_Configure:
					NS_DURING
					FSPlugInObject	*plugin;
					
						plugin = [[context->children objectAtIndex:0] pointerValue];
						if(plugin && plugin->plugin_interface)
							returncode = (*plugin->plugin_interface)(plugin,FSCoreInterfaceMessage_RespondsTo,NULL);
						else
							returncode = 0;
					NS_HANDLER
						returncode = 0;
					NS_ENDHANDLER
					break;
				
				case FSCoreInterface_Cocoa_ChildrenPath:
				case FSCoreInterface_Cocoa_ChildrenLoaded:
					returncode = 1;
					break;
				
				default:
					returncode = 0;
					break;
			}
			break;
		
		case FSCoreInterfaceMessage_Configure:
			NS_DURING
			FSPlugInObject	*plugin;
			
				plugin = [[context->children objectAtIndex:0] pointerValue];
				if(plugin && plugin->plugin_interface)
					returncode = (*plugin->plugin_interface)(plugin,FSCoreInterfaceMessage_Configure,NULL);
				else
					returncode = -1;
			NS_HANDLER
				returncode = -1;
			NS_ENDHANDLER
			break;
		
		case FSCoreInterface_Cocoa_ChildrenPath:
			if(context->children) [context->children release];
			context->children = [[NSMutableArray alloc] initWithCapacity:0];
			*result = context->paths;
			returncode = 0;
			break;
		
		case FSCoreInterface_Cocoa_ChildrenLoaded:
			[context->children addObject:[NSValue valueWithPointer:*result]];
			returncode = 0;
			break;
	}
	[pool release];
	return returncode;
}